#---------------------------------------------------------------------#
# ޷ ȭ ... *^^*
#---------------------------------------------------------------------#
sub load_cal {
	my ($year, $mon, $day) = @_;
	my (%AVS, %CAL_ICON, %CATE_ICON, $localtime, $first_week, @week, $sun_col, $sat_col, $today_col, $blank_col, $week_line, $week_num, $day_val, @day_cnt, $last_day, $date_opt);
	
	
	if(($year  < 1900) || ($year >= 2038)) {
		print "Content-type: text/html\n\n";
		print "<script language=javascript>\n";
		print "alert(\"$CAL{'err_year'}\");\n";
		print "history.go(-1);\n";
		print "</script>\n";
		exit;
	}
	
	use Time::Local; # 1901 ¥ 2038  ¥   .
	$localtime = timegm(undef, undef, undef, 1, $mon-1, $year-1900);
	$first_week = (localtime($localtime))[6];

	%ANV = &load_msg("$CONF{'lang'}", "anniversary_db"); #  ؽƮ ҷ... *^^*
	%CAL_ICON = &load_msg("$CONF{'lang'}", "cal_icon");
	
	foreach (keys %CAL_ICON) {
		my $key = $_;
		my $value = $CAL_ICON{$key};
		$CATE_ICON{$value} = $key;
	}
	$CATE_ICON{'etc'} = "etc.gif";

	#  ¥ ϱ
	@day_cnt = qw(31 28 31 30 31 30 31 31 30 31 30 31);
	$last_day = $day_cnt[$mon - 1];
	$last_day++ if(($mon == 2) && ((($year%4 == 0) && ($year%100 != 0)) || ($year%400 == 0)));
	
	@week = split(/ /, $CAL{'week'});
		
	$day = $last_day if($day > $last_day);
	
	$date_opt = "&year=$year&mon=$mon&day=$day";

	$sun_col = "red";
	$sat_col = "blue";
	$today_col = "$CONF{'select_color'}";
	$blank_col = "$CONF{'tr_color01'}";

	$load_cal .= "<table width=100% border=1 cellpadding=2 cellspacing=0 bordercolordark=\"$CONF{'head_color'}\" bordercolorlight=\"$CONF{'hfont_color'}\">\n";
	$load_cal .= "<tr bgcolor=\"$CONF{'head_color'}\">\n";
	foreach $week_num(0..6) {
		my $week_color = ($week_num == 0) ? "$sun_col" : ($week_num == 6) ? "$sat_col" : "$CONF{'hfont_color'}"; 
		$load_cal .= "<td align=center><font color=$week_color>$week[$week_num]</font></td>";
	}
	$load_cal .= "</tr>\n";
	for $week_line(0..5) {
		$load_cal .= "<tr>";
		for $week_num(0..6) {
			$day_val = 1 if(($week_line == 0) && ($first_week == $week_num));
			# üŷ
			my ($evt_val, $anv_date, $anv_val, $anv_data, $holy_val);
			$anv_date = sprintf("%02d", $mon).".".sprintf("%02d", $day_val);
			if($day_val && $ANV{$anv_date}) {
				($anv_data, $holy_val) = split(/\|/, $ANV{$anv_date}); 
				if($CONF{'no_anv_view'} eq "") {
					my @anv = split(/\,/, $anv_data);
					foreach (@anv) {
						$anv_val .= "<font color=\"$CONF{'font_color'}\" class=small>$_</font><br>";
					}
				}
			}
			
			if($day_val && (-e "$data_dir/num/$year.$mon.$day_val.cgi")) {
				open(DATE, "$data_dir/num/$year.$mon.$day_val.cgi");
				chomp(my @idx = <DATE>);
				close(DATE);
				
				foreach (@idx) {
					my ($name, $email, $home, $subject, $date, $open, $link_file, $org_file, $size, $category, $pass, $html_ok, $auto_link, $auto_br, $comment, $pre_view, $screen_shot, $ip, $brw, $mod_date, $mem_id, $evt_icon);
					if($CONF{'cmt_preview'}) {
						($name, $email, $home, $subject, $date, $open, $link_file, $org_file, $size, $category, $pass, $html_ok, $auto_link, $auto_br, $comment, $pre_view, $screen_shot, $ip, $brw, $mod_date, $mem_id) = &read_gul("$_", "cmt");
						$comment = &conv_cmt("view", $comment, "", "on");
						
						my(@cmt, $tmp_cnt, $view_cmt);
						@cmt = split(/<br>/, $comment);
						$tmp_cnt = 0;
						foreach (@cmt) {
							last if($tmp_cnt == $CONF{'leng_cmt'});
							$view_cmt .= "$_<br>";
							$tmp_cnt++;
						}				

						$on_mousemove = "onMouseMove=\"view_menu('sub_cmt_$_$day_val', '', event, 'cmt');\"";
						$span_start = "<span id=cmt_$_$day_val style=\"visibility:visible;cursor:hand\" onMouseOut=\"hide_menu('sub_cmt_$_$day_val');\">";
						$span_end = "</span>";
						$div_val .= "<div id=sub_cmt_$_$day_val class=hide_sub><table border=0 cellpadding=3 cellspacing=0 width=$div_width><tr><td class=cont>$view_cmt</td></tr></table></div>";
					}
					else {
						(undef, undef, undef, $subject, undef, undef, undef, undef, undef, $category) = &read_gul("$_");
					}
					
					$evt_icon = "<img src=$img_url/icon_img/soya_diary/$CATE_ICON{$category} border=0 width=13 height=13 alt=\"$category\" align=absmiddle>" if((-e "$main_dir/img/icon_img/soya_diary/$CATE_ICON{$category}") && $CONF{'no_icon'} eq "");
					$evt_val .= ($open eq "no" && ($CONF{'lock_use'} || $CONF{'closed_board'}) || $CONF{'reject_view'}) ? "<a href=\"$cgi_url?id=$FORM{'id'}&action=view&gul=$_&page=$page&go_cnt=$go_cnt$date_opt$sort_opt$cate_opt$search_opt\">$evt_icon $subject</a><br>" : "$span_start<a href=\"$cgi_url?id=$FORM{'id'}&action=view&gul=$_&page=$page&go_cnt=$go_cnt$date_opt$sort_opt$cate_opt$search_opt\" $on_mousemove>$evt_icon $subject</a>$span_end<br>";
				}
			}

			my $week_color = ($week_num == 0 || $holy_val) ? "$sun_col" : ($week_num == 6) ? "$sat_col" : "$CONF{'font_color'}"; 
			$week_val = ($day_val) ? "<a href=$cgi_url?id=$FORM{'id'}&action=input_form&year=$year&mon=$mon&day=$day_val title=\"$CAL{'write_msg'}\"><font color=$week_color class=small>$day_val</font></a>" : "&nbsp;";
			$day_color = ($day_val == $day) ? "$today_col" : ($day_val eq "") ? "$blank_col" : "$CONF{'tr_color02'}";
			$load_cal .= "<td nowrap width=$sel_width height=$sel_height valign=top bgcolor=$day_color class=cont>$week_val $evt_val $anv_val</td>";
			if(($day_val >= 1) && $day_val < $last_day) {
				$day_val++;
			}
			else {
				$day_val = "";
			}
		}
		$load_cal .= "</tr>\n";
		last unless($day_val);
	}
	$load_cal .= "</table>\n";

	return $load_cal;
}

return 1;